<template>
  <div id="home">
    <v-app dark>
      <div class="overflow-hidden bg-gray-100">
        <div
          id="mainSidebar"
          class="sidebar flex flex-col justify-between bg-red border relative"
          :class="drawer == true ? 'open' : ''"
        >
          <div
            class="bg-white w-4 h-10 flex items-center toggle-sidebar-desktop"
            style="top: 8%; border-radius: 0px 8px 8px 0px; transition all 0.4s"
            :class="drawer == true ? 'toggle-open' : 'toggle-close'"
          >
            <button
              @click="toggleSideBar()"
              class="flex items-center justify-center cursor-pointer"
            >
              <svg
                v-if="drawer == true"
                xmlns="http://www.w3.org/2000/svg"
                fill="none"
                viewBox="0 0 24 24"
                stroke-width="1.5"
                stroke="currentColor"
                class="w-4 h-5"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  d="M15.75 19.5L8.25 12l7.5-7.5"
                />
              </svg>
              <svg
                v-else
                xmlns="http://www.w3.org/2000/svg"
                viewBox="0 0 24 24"
                fill="currentColor"
                class="w-4 h-5"
              >
                <path
                  fill-rule="evenodd"
                  d="M16.28 11.47a.75.75 0 010 1.06l-7.5 7.5a.75.75 0 01-1.06-1.06L14.69 12 7.72 5.03a.75.75 0 011.06-1.06l7.5 7.5z"
                  clip-rule="evenodd"
                />
              </svg>
            </button>
          </div>
          <div
            class="relative"
            :style="drawer == true ? '' : 'side-bar-close-desktop'"
          >
            <div @click="onClickCloseSideBarMbMainPage()">
              <nuxt-link to="/seller/dashboard">
                <div class="logo-details flex justify-center">
                  <div
                    v-if="screenWidth > 768"
                    class="items-center flex justify-center min-h-[30px]"
                  >
                    <div class="min-w-[30px] max-w-[30px] h-[30px]">
                      <img
                        src="~/assets/images/logo-not-text.png"
                        alt=""
                        class="w-full h-full"
                      />
                    </div>
                    <div class="logo_name ml-1">
                      <!-- <img
                        src="~/assets/images/Black.png"
                        alt=""
                        class="w-full h-full"
                      /> -->
                      <span class="pl-1 logo-name auth-title">Open site</span>
                    </div>
                  </div>
                  <div
                    v-else
                    class="text-center flex items-center justify-between px-1"
                  >
                    <div class="flex items-center">
                      <div class="min-w-[30px] max-w-[30px] h-[30px]">
                        <img
                          src="~/assets/images/logo-not-text.png"
                          alt=""
                          class="w-full h-full"
                        />
                      </div>
                      <div class="logo_name">
                        <!-- <img
                          src="~/assets/images/Black.png"
                          alt=""
                          class="w-full h-full"
                        /> -->
                        <span class="pl-1 logo-name auth-title">Open site</span>
                      </div>
                    </div>
                    <button class="toggle-sidebar-mb" @click="drawer = !drawer">
                      <svg
                        xmlns="http://www.w3.org/2000/svg"
                        width="24"
                        height="24"
                        viewBox="0 0 24 24"
                        fill="none"
                      >
                        <path
                          d="M3 6H21V8H3V6ZM3 11H21V13H3V11ZM3 16H21V18H3V16Z"
                          fill="black"
                        />
                      </svg>
                    </button>
                  </div>
                </div>
              </nuxt-link>
            </div>

            <ul class="nav-list">
              <li class="sm:px-2 px-1 py-1">
                <div @click="onClickCloseSideBarMb()">
                  <nuxt-link
                    v-if="drawer == true"
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/dashboard"
                    style="transition: 0.4s"
                  >
                    <svg
                      xmlns="http://www.w3.org/2000/svg"
                      viewBox="0 0 24 24"
                      fill="currentColor"
                      class="icon-nav-link svg-icon"
                    >
                      <path
                        d="M11.47 3.84a.75.75 0 011.06 0l8.69 8.69a.75.75 0 101.06-1.06l-8.689-8.69a2.25 2.25 0 00-3.182 0l-8.69 8.69a.75.75 0 001.061 1.06l8.69-8.69z"
                      />
                      <path
                        d="M12 5.432l8.159 8.159c.03.03.06.058.091.086v6.198c0 1.035-.84 1.875-1.875 1.875H15a.75.75 0 01-.75-.75v-4.5a.75.75 0 00-.75-.75h-3a.75.75 0 00-.75.75V21a.75.75 0 01-.75.75H5.625a1.875 1.875 0 01-1.875-1.875v-6.198a2.29 2.29 0 00.091-.086L12 5.43z"
                      />
                    </svg>

                    <span class="links_name">Dashboard</span>
                  </nuxt-link>
                  <nuxt-link
                    v-else
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/dashboard"
                    style="transition: 0.4s"
                  >
                    <svg
                      xmlns="http://www.w3.org/2000/svg"
                      viewBox="0 0 24 24"
                      fill="currentColor"
                      class="icon-nav-link svg-icon"
                    >
                      <path
                        d="M11.47 3.84a.75.75 0 011.06 0l8.69 8.69a.75.75 0 101.06-1.06l-8.689-8.69a2.25 2.25 0 00-3.182 0l-8.69 8.69a.75.75 0 001.061 1.06l8.69-8.69z"
                      />
                      <path
                        d="M12 5.432l8.159 8.159c.03.03.06.058.091.086v6.198c0 1.035-.84 1.875-1.875 1.875H15a.75.75 0 01-.75-.75v-4.5a.75.75 0 00-.75-.75h-3a.75.75 0 00-.75.75V21a.75.75 0 01-.75.75H5.625a1.875 1.875 0 01-1.875-1.875v-6.198a2.29 2.29 0 00.091-.086L12 5.43z"
                      />
                    </svg>
                  </nuxt-link>
                </div>
              </li>
              <li class="sm:px-2 px-1 py-1">
                <div @click="onClickCloseSideBarMb()">
                  <nuxt-link
                    v-if="drawer == true"
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/analytics"
                    style="transition: 0.4s"
                  >
                    <v-icon class="icon-nav-link svg-icon">
                      mdi-chart-timeline-variant
                    </v-icon>
                    <span class="links_name">Analytic</span>
                  </nuxt-link>
                  <nuxt-link
                    v-else
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/analytics"
                    style="transition: 0.4s"
                  >
                    <v-icon class="icon-nav-link svg-icon">
                      mdi-chart-timeline-variant
                    </v-icon>
                  </nuxt-link>
                </div>
              </li>
              <li class="sm:px-2 px-1 py-1">
                <div @click="onClickCloseSideBarMb()">
                  <nuxt-link
                    v-if="drawer == true"
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/products"
                    style="transition: 0.4s"
                  >
                    <v-icon class="icon-nav-link svg-icon">
                      mdi-shopping
                    </v-icon>

                    <span class="links_name">Products</span>
                  </nuxt-link>
                  <nuxt-link
                    v-else
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/products"
                    style="transition: 0.4s"
                  >
                    <v-icon class="icon-nav-link svg-icon">
                      mdi-shopping
                    </v-icon>
                  </nuxt-link>
                </div>
              </li>
              <li class="sm:px-2 px-1 py-1">
                <div @click="onClickCloseSideBarMb()">
                  <nuxt-link
                    v-if="drawer == true"
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/order"
                    style="transition: 0.4s"
                  >
                    <svg
                      xmlns="http://www.w3.org/2000/svg"
                      viewBox="0 0 24 24"
                      fill="currentColor"
                      class="icon-nav-link svg-icon"
                    >
                      <path
                        d="M2.25 2.25a.75.75 0 000 1.5h1.386c.17 0 .318.114.362.278l2.558 9.592a3.752 3.752 0 00-2.806 3.63c0 .414.336.75.75.75h15.75a.75.75 0 000-1.5H5.378A2.25 2.25 0 017.5 15h11.218a.75.75 0 00.674-.421 60.358 60.358 0 002.96-7.228.75.75 0 00-.525-.965A60.864 60.864 0 005.68 4.509l-.232-.867A1.875 1.875 0 003.636 2.25H2.25zM3.75 20.25a1.5 1.5 0 113 0 1.5 1.5 0 01-3 0zM16.5 20.25a1.5 1.5 0 113 0 1.5 1.5 0 01-3 0z"
                      />
                    </svg>

                    <span class="links_name">Orders</span>
                  </nuxt-link>
                  <nuxt-link
                    v-else
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/order"
                    style="transition: 0.4s"
                  >
                    <svg
                      xmlns="http://www.w3.org/2000/svg"
                      viewBox="0 0 24 24"
                      fill="currentColor"
                      class="icon-nav-link svg-icon"
                    >
                      <path
                        d="M2.25 2.25a.75.75 0 000 1.5h1.386c.17 0 .318.114.362.278l2.558 9.592a3.752 3.752 0 00-2.806 3.63c0 .414.336.75.75.75h15.75a.75.75 0 000-1.5H5.378A2.25 2.25 0 017.5 15h11.218a.75.75 0 00.674-.421 60.358 60.358 0 002.96-7.228.75.75 0 00-.525-.965A60.864 60.864 0 005.68 4.509l-.232-.867A1.875 1.875 0 003.636 2.25H2.25zM3.75 20.25a1.5 1.5 0 113 0 1.5 1.5 0 01-3 0zM16.5 20.25a1.5 1.5 0 113 0 1.5 1.5 0 01-3 0z"
                      />
                    </svg>
                  </nuxt-link>
                </div>
              </li>
              <!-- <li class="sm:px-2 px-1 py-1">
                <div @click="onClickCloseSideBarMb()">
                  <nuxt-link
                    v-if="drawer == true"
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/discounts"
                    style="transition: 0.4s"
                  >
                    <v-icon class="icon-nav-link svg-icon"> mdi-gift </v-icon>

                    <span
                      class="links_name"
                      :class="drawer == true ? 'flex' : 'hidden'"
                      >Discounts</span
                    >
                  </nuxt-link>
                  <nuxt-link
                    v-else
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/discounts"
                    style="transition: 0.4s"
                  >
                    <v-icon class="icon-nav-link svg-icon"> mdi-gift </v-icon>
                  </nuxt-link>
                </div>
              </li> -->
              <li class="sm:px-2 px-1 py-1">
                <div @click="onClickCloseSideBarMb()">
                  <nuxt-link
                    v-if="drawer == true"
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/users"
                    style="transition: 0.4s"
                  >
                    <v-icon class="icon-nav-link svg-icon">
                      mdi-account-supervisor-circle
                    </v-icon>

                    <span class="links_name">Users</span>
                  </nuxt-link>
                  <nuxt-link
                    v-else
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/users"
                    style="transition: 0.4s"
                  >
                    <v-icon class="icon-nav-link svg-icon">
                      mdi-account-supervisor-circle
                    </v-icon>
                  </nuxt-link>
                </div>
              </li>
              <li class="px-2 py-1 menu-sidebar-seller">
                <v-list v-if="drawer == true" class="py-0">
                  <v-list-group
                    v-model="openListDropdown"
                    prepend-icon="mdi-cog"
                    no-action
                    :value="isActiveListGroupSetting"
                  >
                    <template v-slot:activator>
                      <v-list-item-content>
                        <v-list-item-title>
                          <p class="mb-0 !ml-0 links_name">Settings</p>
                        </v-list-item-title>
                      </v-list-item-content>
                    </template>
                    <div @click="onClickCloseSideBarMb()" class="pl-6">
                      <nuxt-link
                        v-for="(setting, i) in listSetting"
                        :key="i"
                        :to="setting.link"
                        class="text-decoration-none"
                      >
                        <div class="d-flex align-center c-pointer p-2">
                          <p class="mb-0 links_name">
                            {{ setting.title }}
                          </p>
                        </div>
                      </nuxt-link>
                    </div>
                  </v-list-group>
                </v-list>
                <div v-else>
                  <button
                    @click="openDropdown()"
                    class="p-2 items-sidebar hover:rounded-lg w-full !flex items-center"
                    :class="
                      drawer == true
                        ? 'hidden'
                        : 'flex justify-center items-center'
                    "
                    style="transition: 0.4s; color: #7a8c96"
                  >
                    <span class="flex items-center">
                      <svg
                        xmlns="http://www.w3.org/2000/svg"
                        viewBox="0 0 24 24"
                        class="icon-nav-link svg-icon mdi-icon-cog"
                      >
                        <title>cog</title>
                        <path
                          d="M12,15.5A3.5,3.5 0 0,1 8.5,12A3.5,3.5 0 0,1 12,8.5A3.5,3.5 0 0,1 15.5,12A3.5,3.5 0 0,1 12,15.5M19.43,12.97C19.47,12.65 19.5,12.33 19.5,12C19.5,11.67 19.47,11.34 19.43,11L21.54,9.37C21.73,9.22 21.78,8.95 21.66,8.73L19.66,5.27C19.54,5.05 19.27,4.96 19.05,5.05L16.56,6.05C16.04,5.66 15.5,5.32 14.87,5.07L14.5,2.42C14.46,2.18 14.25,2 14,2H10C9.75,2 9.54,2.18 9.5,2.42L9.13,5.07C8.5,5.32 7.96,5.66 7.44,6.05L4.95,5.05C4.73,4.96 4.46,5.05 4.34,5.27L2.34,8.73C2.21,8.95 2.27,9.22 2.46,9.37L4.57,11C4.53,11.34 4.5,11.67 4.5,12C4.5,12.33 4.53,12.65 4.57,12.97L2.46,14.63C2.27,14.78 2.21,15.05 2.34,15.27L4.34,18.73C4.46,18.95 4.73,19.03 4.95,18.95L7.44,17.94C7.96,18.34 8.5,18.68 9.13,18.93L9.5,21.58C9.54,21.82 9.75,22 10,22H14C14.25,22 14.46,21.82 14.5,21.58L14.87,18.93C15.5,18.67 16.04,18.34 16.56,17.94L19.05,18.95C19.27,19.03 19.54,18.95 19.66,18.73L21.66,15.27C21.78,15.05 21.73,14.78 21.54,14.63L19.43,12.97Z"
                        />
                      </svg>
                    </span>
                  </button>
                </div>
              </li>
            </ul>
          </div>

          <div
            class="px-0 flex flex-col justify-end items-center py-4 menu-account"
            :style="
              drawer == true
                ? 'max-width: 215px; min-width: 200px;'
                : 'max-width: 50px; min-width: 45px; max-height:68px'
            "
            style="transition: all 0.2s"
          >
            <v-menu
              class="w-full !rounded-md"
              content-class="menu-account"
              offset-y
              top
              nudge-top="10px"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-chip
                  v-bind="attrs"
                  v-on="on"
                  class="w-full chip-menu"
                  style="height: 52px"
                  :class="drawer == false ? 'justify-center flex px-0' : ''"
                  color="#F5F7F9"
                >
                  <div class="flex align-center">
                    <v-icon size="27" color="#95a5a6">
                      mdi-account-circle
                    </v-icon>

                    <div v-if="drawer == true" class="ml-1">
                      <p class="mb-0 text-sm font-semibold text-content-main">
                        {{
                          userInfo && userInfo.role === 1 ? "Admin" : "Seller"
                        }}
                      </p>
                      <p class="mb-0 text-sm text-content-subtitle">
                        {{
                          userInfo &&
                          userInfo.email &&
                          userInfo.email.length > 15
                            ? userInfo.email.slice(0, 18) + "..."
                            : userInfo.email
                        }}
                      </p>
                    </div>
                  </div>
                </v-chip>
              </template>
              <div class="white">
                <div
                  class="list-hover c-pointer px-3 py-1"
                  @click="$router.push('/admin/account-setting')"
                >
                  <p
                    class="mb-0 fsize-14-400 !p-2"
                    style="color: rgba(0, 0, 0, 0.87)"
                  >
                    Account Setting
                  </p>
                </div>
                <v-divider></v-divider>
                <div class="list-hover c-pointer px-3 py-1" @click="onLogout()">
                  <p
                    class="mb-0 fsize-14-400 !p-2"
                    style="color: rgba(0, 0, 0, 0.87)"
                  >
                    Logout
                  </p>
                </div>
              </div>
            </v-menu>
          </div>
        </div>
        <v-main
          class="home-section overflow-hidden dark:!bg-bg-main-dark h-full"
        >
          <div id="header" class="bg-white py-3 fixed top-0 w-full z-20">
            <button class="absolute left-2" @click="drawer = !drawer">
              <svg
                xmlns="http://www.w3.org/2000/svg"
                width="24"
                height="24"
                viewBox="0 0 24 24"
                fill="none"
              >
                <path
                  d="M3 6H21V8H3V6ZM3 11H21V13H3V11ZM3 16H21V18H3V16Z"
                  fill="black"
                />
              </svg>
            </button>
            <nuxt-link to="/admin/dashboard">
              <div class="flex">
                <div class="min-w-[30px] max-w-[30px] h-[30px]">
                  <img
                    src="~/assets/images/logo-not-text.png"
                    alt=""
                    class="w-full h-full"
                  />
                </div>
                <div class="logo_name ml-1">
                  <span class="pl-1 logo-name auth-title">Open site</span>
                </div>
              </div>
            </nuxt-link>
          </div>
          <div
            v-show="drawer == true"
            v-if="screenWidth < 768"
            @click="onClickCloseSideBarMbMainPage()"
            class="overlay-bg"
          ></div>
          <div
            @click="onClickCloseSideBarMbMainPage()"
            class="py-5 lg:!px-6 !px-4 mx-auto max-w-[1440px] h-full md:mt-0 mt-[56px]"
          >
            <LoadingComponent v-show="loadingFullPage" />
            <div v-show="!loadingFullPage" class="pb-6">
              <Nuxt />
            </div>
          </div>
        </v-main>
      </div>
    </v-app>
  </div>
</template>

<script lang="ts">
import {
  Component,
  getModule,
  Prop,
  Vue,
  Watch,
} from "nuxt-property-decorator";
import { api } from "~/common/constaint";
import UserModule from "~/store/user";
import { redirectPage } from "~/utils/apiHanlers";

@Component({
  components: {
    LoadingComponent: () => import("@/components/Utils/Loading/index.vue"),
  },
})
export default class DefaultLayout extends Vue {
  drawer = true;
  screenWidth = 0;
  openListDropdown = false;
  adminProduct = getModule(UserModule, this.$store);

  listSetting = [
    { title: "General", link: "/admin/settings/general" },
    { title: "Payment Methods", link: "/admin/settings/payment-method" },
    { title: "Domains", link: "/admin/settings/domain" },
    { title: "Emails", link: "/admin/settings/emails" },
    { title: "Abandon Mail", link: "/admin/settings/abandon" },
    { title: "Storefront", link: "/admin/settings/storefront" },
    { title: "Shipping", link: "/admin/shipping" },
  ];

  listAnalytics = [
    { title: "Sessions", link: "/seller/analytics/sessions" },
    { title: "Revenue", link: "/seller/analytics/revenue" },
  ];
  get href() {
    const path = this.$route.path;
    return path || "";
  }
  onClickCloseSideBarMb() {
    if (this.screenWidth < 768) {
      this.drawer = !this.drawer;
    }
  }
  get isActiveListGroupShop() {
    const route = this.$route.path;
    return route.includes("/settings") ? true : false;
  }

  get isActiveListGroupAnalytics() {
    const route = this.$route.path;
    return route.includes("/analytics") ? true : false;
  }

  openDropdown() {
    this.drawer = true;
    this.openListDropdown = true;
  }

  onClickCloseSideBarMbMainPage() {
    if (this.screenWidth < 768) {
      this.drawer = false;
    }
  }
  isActiveListItemSetting(link: string) {
    const route = this.$route.path;
    if (route.includes(link)) {
      return route;
    }
    return "";
  }

  get loadingFullPage() {
    return this.$store.state.adminProduct.loadingFullPage;
  }

  created() {
    if (
      //@ts-ignore
      this.$vuetify.breakpoint.name !== "lg" &&
      //@ts-ignore
      this.$vuetify.breakpoint.name !== "xl"
    ) {
      this.drawer = false;
    } else {
      this.drawer = true;
    }
  }

  get isActiveListGroupSetting() {
    const route = this.$route.path;
    return route.includes("/settings") ? true : false;
  }
  isActiveListItem(link: string) {
    const route = this.$route.path;
    if (route.includes(link)) {
      return route;
    }
    return "";
  }
  mounted() {
    this.updateScreenWidth();
    this.onGetMe();
  }
  onScreenResize() {
    window.addEventListener("resize", () => {
      this.updateScreenWidth();
    });
  }
  async onGetMe() {
    await this.$store.dispatch("user/onGetMe", { ctx: this });
  }

  get userInfo() {
    return this.$store.state.user.userInfo;
  }

  get convertImage() {
    const siteInfo = this.$store.state.setting.siteInfo;
    if (siteInfo && siteInfo.logo) {
      return `${api}/${siteInfo.logo}`;
    }
    return "";
  }

  async onLogout() {
    try {
      this.$axios.setHeader("Authorization", "");
      await this.$store.dispatch("user/logout", { store: this.$store });
      redirectPage(`/auth/login`);
    } catch (error) {
      console.log("error :>> ", error);
    }
  }
  updateScreenWidth() {
    this.screenWidth = window.innerWidth;
  }

  toggleSideBar() {
    this.drawer = !this.drawer;
  }

  @Watch("screenWidth")
  closeSideBarMb(value: number) {
    if (value < 640) {
      this.drawer = false;
    }
  }
}
</script>

<style>
.logo-name {
  background: -webkit-linear-gradient(to right, #4745a1, #ae2cf1);
  background: linear-gradient(to right, #4745a1, #ae2cf1);
  -webkit-background-clip: text;
  background-clip: text;
  -webkit-text-fill-color: transparent;
  color: transparent;
  text-wrap: nowrap;
  font-weight: 800;
  font-size: 1.25rem;
}
</style>
